gtkmm: Gdk::PixbufAnimationIter Class Reference

gtkmm 4.18.0

Public Member Functions | Static Public Member Functions | Related Symbols | List of all members
Gdk::PixbufAnimationIter Class Reference

An iterator which points to a certain position in a PixbufAnimation. More...

`#include <gdkmm/pixbufanimationiter.h>`

Inheritance diagram for Gdk::PixbufAnimationIter:
[legend]

## Public Member Functions
| PixbufAnimationIter (PixbufAnimationIter && src) noexcept
PixbufAnimationIter & | operator= (PixbufAnimationIter && src) noexcept
| ~PixbufAnimationIter () noexcept override
GdkPixbufAnimationIter * | gobj ()
| Provides access to the underlying C GObject.
const GdkPixbufAnimationIter * | gobj () const
| Provides access to the underlying C GObject.
GdkPixbufAnimationIter * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
int | get_delay_time () const
| Gets the number of milliseconds the current pixbuf should be displayed, or -1 if the current pixbuf should be displayed forever.
Glib::RefPtr< Gdk::Pixbuf > | get_pixbuf ()
| Gets the current pixbuf which should be displayed.
Glib::RefPtr< const Gdk::Pixbuf > | get_pixbuf () const
| Gets the current pixbuf which should be displayed.
bool | on_currently_loading_frame () const
| Used to determine how to respond to the area_updated signal on Gdk::PixbufLoader when loading an animation.
bool | advance (gint64 current_time=g_get_real_time())
| Possibly advances an animation to a new frame.
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data_with_c_callback (const Quark &key, void *data, GDestroyNotify notify)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Gdk::PixbufAnimationIter > | wrap (GdkPixbufAnimationIter * object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Detailed Description

An iterator which points to a certain position in a PixbufAnimation.

## Constructor & Destructor Documentation

## ◆ PixbufAnimationIter()

Gdk::PixbufAnimationIter::PixbufAnimationIter | ( | PixbufAnimationIter && | src | ) |
| noexcept

## ◆ ~PixbufAnimationIter()

Gdk::PixbufAnimationIter::~PixbufAnimationIter | ( |  | ) |
| overridenoexcept

## Member Function Documentation

## ◆ advance()

bool Gdk::PixbufAnimationIter::advance | ( | gint64 | current_time = g_get_real_time() | ) |

Possibly advances an animation to a new frame.

Chooses the frame based on the start time passed to Gdk::PixbufAnimation::get_iter().

current_time would normally come from g_get_real_time(), and must be greater than or equal to the time passed to Gdk::PixbufAnimation::get_iter(), and must increase or remain unchanged each time get_pixbuf() is called. That is, you can't go backward in time; animations only play forward.

As a shortcut, the default value of current_time is g_get_real_time(). So you only need to explicitly pass current_time if you're doing something odd like playing the animation at double speed.

If this function returns `false`, there's no need to update the animation display, assuming the display had been rendered prior to advancing; if `true`, you need to call get_pixbuf() and update the display with the new pixbuf.

Parameters

  current_time | Current time.

Returns
  `true` if the image may need updating.

## ◆ get_delay_time()

int Gdk::PixbufAnimationIter::get_delay_time | ( |  | ) | const

Gets the number of milliseconds the current pixbuf should be displayed, or -1 if the current pixbuf should be displayed forever.

Glib::SignalTimeout::connect() conveniently takes a timeout in milliseconds, so you can use a timeout to schedule the next update.

Note that some formats, like GIF, might clamp the timeout values in the image file to avoid updates that are just too quick. The minimum timeout for GIF images is currently 20 milliseconds.

Returns
  Delay time in milliseconds (thousandths of a second).

## ◆ get_pixbuf() [1/2]

Glib::RefPtr< Gdk::Pixbuf > Gdk::PixbufAnimationIter::get_pixbuf | ( |  | ) |

Gets the current pixbuf which should be displayed.

The pixbuf might not be the same size as the animation itself (Gdk::Pixbuf::get_width(), Gdk::Pixbuf::get_height()).

This pixbuf should be displayed for get_delay_time() milliseconds.

The returned pixbuf will become invalid when the iterator advances to the next frame, which may happen anytime you call advance(). Copy the pixbuf to keep it, with Gdk::Pixbuf::copy() as it may get recycled as you advance the iterator.

Returns
  The pixbuf to be displayed.

## ◆ get_pixbuf() [2/2]

Glib::RefPtr< const Gdk::Pixbuf > Gdk::PixbufAnimationIter::get_pixbuf | ( |  | ) | const

Gets the current pixbuf which should be displayed.

The pixbuf might not be the same size as the animation itself (Gdk::Pixbuf::get_width(), Gdk::Pixbuf::get_height()).

This pixbuf should be displayed for get_delay_time() milliseconds.

The returned pixbuf will become invalid when the iterator advances to the next frame, which may happen anytime you call advance(). Copy the pixbuf to keep it, with Gdk::Pixbuf::copy() as it may get recycled as you advance the iterator.

Returns
  The pixbuf to be displayed.

## ◆ get_type()

static GType Gdk::PixbufAnimationIter::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GdkPixbufAnimationIter * Gdk::PixbufAnimationIter::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GdkPixbufAnimationIter * Gdk::PixbufAnimationIter::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GdkPixbufAnimationIter * Gdk::PixbufAnimationIter::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ on_currently_loading_frame()

bool Gdk::PixbufAnimationIter::on_currently_loading_frame | ( |  | ) | const

Used to determine how to respond to the area_updated signal on Gdk::PixbufLoader when loading an animation.

The `::area_updated` signal is emitted for an area of the frame currently streaming in to the loader. So if you're on the currently loading frame, you will need to redraw the screen for the updated area.

Returns
  `true` if the frame we're on is partially loaded, or the last frame.

## ◆ operator=()

PixbufAnimationIter & Gdk::PixbufAnimationIter::operator= | ( | PixbufAnimationIter && | src | ) |
| noexcept

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Gdk::PixbufAnimationIter > wrap | ( | GdkPixbufAnimationIter * | object,
|  | bool | take_copy = false )
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.